#
# Conditional build:
%bcond_without	tex	# don't build tex documentation
#
%include	/usr/lib/rpm/macros.perl
%define		pari_version		2.5.5
%define		gp2c_version		0.0.8
%define		math_pari_version	2.01080605
Summary:	Number Theory-oriented Computer Algebra System
Summary(pl.UTF-8):	Komputerowy system obliczeń algebraicznych zorientowany na metody teorii liczb
Name:		parigp
Version:	%{pari_version}
Release:	17
License:	GPL
Group:		Applications/Math
Source0:	ftp://megrez.math.u-bordeaux.fr/pub/pari/unix/pari-%{pari_version}.tar.gz
# Source0-md5:	fbd6402f8d3d3213b0633ab9ef4a63d0
Source1:	ftp://megrez.math.u-bordeaux.fr/pub/pari/packages/galdata.tgz
# Source1-md5:	f9f61b2930757a785b568e5d307a7d75
Source2:	ftp://megrez.math.u-bordeaux.fr/pub/pari/GP2C/gp2c-%{gp2c_version}.tar.gz
# Source2-md5:	b29599e06aea3b0a7d370de3d955fdb2
Source3:	http://www.cpan.org/modules/by-module/Math/Math-Pari-%{math_pari_version}.tar.gz
# Source3-md5:	ccb3da2bdce184a5df3f52cfa8b43a85
Source4:	%{name}.desktop
Source5:	%{name}.png
Patch0:		%{name}-target_arch.patch
Patch1:		%{name}-termcap.patch
Patch2:		%{name}-arch.patch
Patch3:		perl-Math-Pari-crash-workaround.patch
Patch4:		perl-Math-Pari-update.patch
Patch5:		%{name}-noproccpuinfo.patch
Patch6:		gmp-version.patch
Patch7:		Math-Pari-escape-left-braces-in-regex.patch
Patch8:		escape-left-braces-in-regex.patch
Patch9:		perl-no-dot-in-inc.patch
URL:		http://pari.math.u-bordeaux.fr/
BuildRequires:	autoconf
BuildRequires:	ctags
BuildRequires:	gmp-devel
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	readline-devel >= 4.2
BuildRequires:	rpm-perlprov >= 3.0.3-16
%if %{with tex}
BuildRequires:	texlive
BuildRequires:	texlive-amstex
BuildRequires:	texlive-csplain
BuildRequires:	texlive-dvips
BuildRequires:	texlive-fonts-cm
BuildRequires:	texlive-format-pdflatex
BuildRequires:	texlive-plain
BuildRequires:	texlive-pdftex
BuildRequires:	texlive-tex-babel
BuildRequires:	texlive-tex-ruhyphen
%endif
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-util-imake
Requires:	pari = %{pari_version}-%{release}
Requires:	xdvi
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PARI/GP is a package which is aimed at efficient computations in
number theory, but also contains a large number of other useful
functions. It is somewhat related to a Computer Algebra System, but is
not really one since it treats symbolic expressions as mathematical
entities such as matrices, polynomials, series, etc..., and not as
expressions per se. However it is often much faster than other CAS,
and contains a large number of specific functions not found elsewhere,
essentially for use in number theory.

%description -l pl.UTF-8
System PARI/GP jest przeznaczony do wydajnych obliczeń z zakresu
teorii liczb, ale zawiera również inne przydatne funkcje. Jest nieco
spokrewniony z Komputerowymi Systemami Algebraicznymi, ale nie
identyczny, ponieważ traktuje wyrażenia symboliczne jako obiekty
matematyczne (macierze, wielomiany, szeregi itp.) a nie jako wyrażenia
same w sobie. Jest jednak często znacznie szybszy od innych KSA-ów a
ponadto zawiera wiele innych funkcji nie spotykanych gdzie indziej, a
przydatnych zwłaszcza w teorii liczb.

%package -n pari
Summary:	Shared PARI library (required by the parigp package)
Summary(pl.UTF-8):	Biblioteka współdzielona PARI (wymagana przez pakiet parigp)
Group:		Libraries

%description -n pari
Shared PARI library. You need it to run PARI/GP.

%description -n pari -l pl.UTF-8
Biblioteka współdzielona PARI. Potrzebujesz jej do uruchomienia
PARI/GP.

%package -n pari-devel
Summary:	Include files for PARI shared library
Summary(pl.UTF-8):	Pliki nagłówkowe do biblioteki współdzielonej PARI
Group:		Development/Libraries
Requires:	pari = %{pari_version}-%{release}

%description -n pari-devel
Include files for shared PARI library. You need them to use PARI
routines in you own programs.

%description -n pari-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki współdzielonej PARI. Będziesz ich
potrzebował, jeżeli będziesz chciał wykorzystywać procedury PARI w
swoich programach.

%package -n pari-static
Summary:	Static PARI library
Summary(pl.UTF-8):	Statyczna biblioteka PARI
Group:		Development/Libraries
Requires:	pari-devel = %{pari_version}-%{release}

%description -n pari-static
Static PARI library. You need it to statically link your programs with
PARI.

%description -n pari-static -l pl.UTF-8
Biblioteka statyczna PARI. Potrzebujesz jej do konsolidowania
statycznego swoich programów korzystających z biblioteki PARI.

%package demos
Summary:	Example PARI/GP scripts
Summary(pl.UTF-8):	Przykładowe skrypty pisane w języku PARI/GP
Group:		Applications/Math
Requires:	%{name} = %{pari_version}-%{release}

%description demos
Example PARI/GP scripts. You can write such programs on your own.

%description demos -l pl.UTF-8
Przykładowe skrypty pisane w języku PARI/GP. Sam możesz takie napisać.

%package galdata
Summary:	Galois data resolvents for PARI/GP
Summary(pl.UTF-8):	Reprezentacje danych Galois fla PARI/GP
Group:		Applications/Math
Requires:	%{name} = %{pari_version}-%{release}

%description galdata
Galois data resolvents for PARI/GP.

%description galdata -l pl.UTF-8
Reprezentacje danych Galois do PARI/GP.

%package gp2c
Summary:	PARI/GP to C translator
Summary(pl.UTF-8):	Konwerter skryptów PARI/GP do języka C
Version:	%{gp2c_version}
Epoch:		1
Group:		Development/Tools
Requires:	pari-devel = %{pari_version}-%{release}
Requires:	%{name} = %{pari_version}-%{release}

%description gp2c
PARI/GP to C translator. Use it to compile your own C programs which
use pari library, without necessarily being a C programmer. Note: use
gp2c-run to run your programs inside the PARI/GP environment.

%description gp2c -l pl.UTF-8
Konwerter skryptów PARI/GP do języka C. Można nim tworzyć własne
programy w C korzystające z biblioteki pari. Znajomość języka C nie
jest wymagana. Uwaga: do uruchamiania programów w środowisku PARI/GP
należy używać gp2c-run.

%package -n perl-Math-Pari
Summary:	Math-Pari perl module
Summary(pl.UTF-8):	Moduł perla Math-Pari
Version:	%{math_pari_version}
Group:		Development/Languages/Perl

%description -n perl-Math-Pari
The Perl interface to the PARI part of GP/PARI.

%description -n perl-Math-Pari -l pl.UTF-8
Interfejs Perla do biblioteki PARI.

%prep
%setup -q -n pari-%{pari_version} -a 2 -a 3
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch8 -p1
%patch9 -p1
cd Math-Pari-%{math_pari_version}
%patch7 -p0

%build
# pari & parigp
./Configure \
	--target=%{_target_cpu} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--sysdatadir=%{_libdir}/parigp \
	--datadir=%{_datadir}/parigp \
	--share-prefix=%{_datadir} \
	--with-readline-lib=%{_libdir} \
	--with-ncurses-lib=%{_libdir} \
	--with-gmp-lib=%{_libdir}


%{__make} -C Olinux-%{_target_cpu} all \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -fno-strict-aliasing -fomit-frame-pointer -fPIC"

%{__make} ctags

%{?with_tex:%{__make} -j1 -C doc docpdf}
%ifarch x32
ln -s Olinux-%{_target_cpu} Olinux-x86_64
%endif
%ifarch %{ix86}
ln -s Olinux-%{_target_cpu} Olinux-ix86
%endif
%ifarch sparc sparc64
# allow building sparc package on sparc64
ln -s Olinux-sparc Olinux-sparc64
%endif

# gp2c
cd gp2c-%{gp2c_version}

ln -sf .. pari
%{__autoconf}
%configure \
	--datadir=%{_datadir}/parigp

%{__make}
%{?with_tex:%{__make} -j1 -C doc docall}

cd ..

# math-pari
cd Math-Pari-%{math_pari_version}
cp -f ../Olinux-%{_target_cpu}/paricfg.h libPARI/paricfg.h
echo '#define DL_DFLT_NAME NULL' >>libPARI/paricfg.h

%{__perl} Makefile.PL \
	INSTALLDIRS=vendor

%{__make} \
	OPTIMIZE="%{rpmcflags} -I$(pwd)/../Olinux-%{_target_cpu}"

# %{__make} test

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_datadir}/parigp/galdata,%{_examplesdir}/parigp} \
	$RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir}}

# parigp, pari & pari-devel
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install src/tags $RPM_BUILD_ROOT%{_datadir}/parigp/misc
install %{SOURCE4} $RPM_BUILD_ROOT%{_desktopdir}
install %{SOURCE5} $RPM_BUILD_ROOT%{_pixmapsdir}

# pari-static
install Olinux-%{_target_cpu}/libpari.a $RPM_BUILD_ROOT%{_libdir}/libpari.a

# parigp-demos
install examples/* $RPM_BUILD_ROOT%{_examplesdir}/parigp

# galdata
tar zxvf %{SOURCE1} -C $RPM_BUILD_ROOT%{_datadir}/parigp/galdata

# gp2c
%{__make} install -C gp2c-%{gp2c_version} \
	DESTDIR=$RPM_BUILD_ROOT

# math-pari
%{__make} install -C Math-Pari-%{math_pari_version} \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/pari.1
echo ".so gp.1" > $RPM_BUILD_ROOT%{_mandir}/man1/pari.1

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/parigp/{examples,doc}
%{__rm} $RPM_BUILD_ROOT%{perl_vendorarch}/Math/libPARI*.pod

%clean
rm -rf $RPM_BUILD_ROOT

%post   -n pari -p /sbin/ldconfig
%postun -n pari -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGES* COMPAT MACHINES NEW README examples/Inputrc %{?with_tex:doc/*.pdf}
%attr(755,root,root) %{_bindir}/gp-2.5
%attr(755,root,root) %{_bindir}/gp
%attr(755,root,root) %{_bindir}/gphelp
%attr(755,root,root) %{_bindir}/tex2mail
%dir %{_datadir}/parigp
%{_datadir}/parigp/PARI
%{_datadir}/parigp/misc
%{_datadir}/parigp/pari.desc
%{_mandir}/man1/[!g]*.1*
%{_mandir}/man1/gp.1*
%{_mandir}/man1/gp-*.1*
%{_mandir}/man1/gphelp.1*
%{_desktopdir}/parigp.desktop
%{_pixmapsdir}/parigp.png

%files -n pari
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpari-gmp.so.*.*.*
%ghost %attr(755,root,root) %{_libdir}/libpari-gmp.so.3
%{_libdir}/parigp

%files -n pari-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpari.so
%{_includedir}/pari

%files -n pari-static
%defattr(644,root,root,755)
%{_libdir}/libpari.a

%files demos
%defattr(644,root,root,755)
%doc examples/EXPLAIN
%{_examplesdir}/parigp

%files galdata
%defattr(644,root,root,755)
%{_datadir}/parigp/galdata

%files gp2c
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gp2c*
%doc gp2c-%{gp2c_version}/{AUTHORS,ChangeLog,NEWS,README,BUGS,doc/*.{html,png}}
%{?with_tex:%doc gp2c-%{gp2c_version}/doc/gp2c.pdf}
%{_datadir}/parigp/gp2c
%{_mandir}/man1/gp2c*.1*

%files -n perl-Math-Pari
%defattr(644,root,root,755)
%doc Math-Pari-%{math_pari_version}/{Changes,README,TODO}
%{perl_vendorarch}/Math/Pari.pm
%{perl_vendorarch}/Math/PariInit.pm
%dir %{perl_vendorarch}/auto/Math/Pari
%attr(755,root,root) %{perl_vendorarch}/auto/Math/Pari/Pari.so
%{_mandir}/man3/Math::Pari.3pm*
%{_mandir}/man3/Math::PariInit.3pm*
%{_mandir}/man3/Math::libPARI.3pm*
%{_mandir}/man3/Math::libPARI.dumb.3pm*
%changelog
* Wed Dec 04 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/parigp.git;a=log;h=master

* Wed Dec 04 2019 Jan Rękorajski <baggins@pld-linux.org> ef877a5
- rebuild with perl 5.30.0
- release 17 (by relup.sh)

* Thu Oct 17 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> ecc6d89
- release 16 (by relup.sh)

* Thu Aug 30 2018 Jan Rękorajski <baggins@pld-linux.org> 3b2bc7b
- rebuild with perl 5.28.0
- release 15 (by relup.sh)

* Wed Aug 29 2018 Marcin Krol <hawk@tld-linux.org> a5222e0
- release 14

* Sun Jul 02 2017 Jan Rękorajski <baggins@pld-linux.org> 0ec0d8a
- rel 13

* Sun Jul 02 2017 Jan Rękorajski <baggins@pld-linux.org> 71b8978
- fix build issues with perl 5.26

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> f04e241
- perl req/prov fix
- release 12 (by relup.sh)

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> 2a51f9e
- rebuild with perl 5.26
- release 11 (by relup.sh)

* Sun Oct 30 2016 Jan Rękorajski <baggins@pld-linux.org> 3c0d27c
- rebuild with perl 5.24.0
- release 10 (by relup.sh)

* Tue Oct 18 2016 Jan Rękorajski <baggins@pld-linux.org> 5c44a44
- rebuild with readline 7.0
- release 9 (by relup.sh)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 9dabce3
- release 8 (by relup.sh)

* Sun May 10 2015 Jan Rękorajski <baggins@pld-linux.org> e6713c6
- disable gmp type size check
- rel 7

* Sun Sep 14 2014 Jan Rękorajski <baggins@pld-linux.org> cbcaee0
- release 6 (by relup.sh)

* Sun Sep 14 2014 Jan Rękorajski <baggins@pld-linux.org> 0df89c3
- removed zero-sized .bs file

* Sun Nov 17 2013 Jakub Bogusz <qboosh@pld-linux.org> 5b9ede9
- restored (and updated) noproccpuinfo patch (still needed on sparc to get generic impl)

* Wed Nov 13 2013 Marcin Krol <hawk@tld-linux.org> c1170d8
- updated parigp to 2.5.5, gp2c to 0.0.8, updated termcap patch,
  removed no-proccpuinfo patch (no longer needed)
- release 5 (perl-Math-Pari version not changed)

* Sun Jun 30 2013 Jakub Bogusz <qboosh@pld-linux.org> df89f09
- one more -j1 for docs make

* Fri Jun 28 2013 Jakub Bogusz <qboosh@pld-linux.org> be03358
- docs build seems racy, use -j1

* Thu Jun 27 2013 Jakub Bogusz <qboosh@pld-linux.org> 6b1f7b5
- release 4

* Thu Jun 27 2013 Jakub Bogusz <qboosh@pld-linux.org> 3d593c5
- updated perl-Math-Pari-update patch, now the module at least loads

